// []-----------------------------------------------------------------------[]
// |                                                                         |
// |                                                                         |
// |  This source and its associated executable are copyright by Jeff Lawson |
// |  of JL Enterprises, however some portions of this code may or may not   |
// |  have been originally inspired by other authors and credit is given if  |
// |  due.  You are encouraged to redistribute this package, but you must    |
// |  include all files originally distributed in this archive in their      |
// |  original state and format and without modifications of any kind.       |
// |  Under no circumstances may you make modifications to this product and  |
// |  redistribute the resulting code or executables.  If you believe you    |
// |  have made some useful or otherwise important enhancements and you      |
// |  would like to share these changes with others, please contact the      |
// |  author through one of the methods listed below.  Additionally, no      |
// |  fees may be charged for the usage of this product by anyone other than |
// |  the author of this file, except for fees (not to exceed US $10) by     |
// |  disk distributors to cover disk duplication and handling.  If there    |
// |  is any need to question this policy, please contact the author.        |
// |  This source code and its executable are distributed without any kind   |
// |  of warranty and the author may not be held accountable for damages of  |
// |  any kind.                                                              |
// |                                                                         |
// |                                                                         |
// |  I can reached via postal mail at:                                      |
// |                                                                         |
// |          Jeff Lawson                                                    |
// |          1893 Kaweah Drive                                              |
// |          Pasadena, CA 91105-2174                                        |
// |          USA                                                            |
// |                                                                         |
// |  or through E-mail at:                                                  |
// |                                                                         |
// |          jlawson@hmc.edu    or   JeffLawson@Aol.Com                     |
// |                                                                         |
// |  also via phone at:                                                     |
// |                                                                         |
// |          (213) 258-5604     or   (213) 258-4264                         |
// |                                                                         |
// []-----------------------------------------------------------------------[]

#include "hofedit.hpp"

// define the item information list
struct item_type item_data[] = {
    {"onion",FOOD},{"sulfur rock",ROCKS},{"fireberry",FOOD},{"blueberry",FOOD},
    {"mushroom",FOOD},{"furniture",MISC},{"gnarly bark",MISC},{"skeleton key",METAL},
    {"plant food",MISC},{"moldy cheese",FOOD},{"anchor",METAL},{"gold anchor",METAL},
    {"feather",MISC},{"alchemist's magnet",METAL},{"letter",MISC},{"letter",MISC},
    {"letter",MISC},{"letter",MISC},{"empty flask",FLASKS},{"reversed empty flask",FLASKS},
    {"quicksand",FLASKS},{"water",FLASKS},{"warm water",FLASKS},{"hot water",FLASKS},
    {"swampwater",FLASKS},{"reptile tears",FLASKS},{"swampsnake potion",FLASKS},
    {"milk",FLASKS},{"bottled ghost",FLASKS},{"cheese",FOOD},{"sandwich",FOOD},{"wool",MISC},
    {"grain stalks",FOOD},{"lettuce",FOOD},{"radish",FOOD},{"horse shoe",METAL},
    {"lucky horse shoe",METAL},{"magnet",METAL},{"shears",METAL},{"ground radish",FOOD},
    {"ground grain",FOOD},{"water bowl",FLASKS},{"(gnarly bark)",ANIMATION},{"(gnarly bark)",ANIMATION},
    {"(gnarly bark)",ANIMATION},{"(fireberry)",ANIMATION},{"(fireberry)",ANIMATION},
    {"(fireberry)",ANIMATION},{"(gold anchor)",ANIMATION},{"(gold anchor)",ANIMATION},
    {"(gold anchor)",ANIMATION},{"mustard",FOOD},{"vinegar",FOOD},{"gold tooth",METAL},
    {"lead tooth",METAL},{"lead slug",METAL},{"gold piece",METAL},{"salt water",FLASKS},
    {"skeptic potion",FLASKS},{"sweet and sour sauce",FOOD},{"orange peel",FOOD},{"wrapper",MISC},
    {"key",METAL},{"fishing rig",MISC},{"voucher",MISC},{"root beer (mug)",FOOD},{"mug",FLASKS},
    {"mud",MISC},{"mud footprint",MISC},{"taffy",FOOD},{"taffy footprint",MISC},{"stick",MISC},
    {"parchment",MISC},{"root beer (bowl)",FOOD},{"taffy (bowl)",FOOD},{"orange peel (bowl)",FOOD},
    {"vinegar (bowl)",FOOD},{"skeptic serum",FLASKS},{"(bottled ghost)",ANIMATION},
    {"(bottled ghost)",ANIMATION},{"(bottled ghost)",ANIMATION},{"(hot water)",ANIMATION},
    {"(hot water)",ANIMATION},{"(hot water)",ANIMATION},{"(warm water)",ANIMATION},
    {"(warm water)",ANIMATION},{"(warm water)",ANIMATION},{"(skeptic potion)",ANIMATION},
    {"(skeptic potion)",ANIMATION},{"(skeptic potion)",ANIMATION},{"(swamp snake potion)",ANIMATION},
    {"(swamp snake potion)",ANIMATION},{"(swamp snake potion)",ANIMATION},{"heavy rock",MISC},
    {"sea shell",MISC},{"star fish",MISC},{"sand dollar",MISC},{"torn cloth",MISC},{"teddy bear",MISC},
    {"leather folio",MISC},{"quill",MISC},{"flying shoes",MISC},{"teddy bear eyes",MISC},
    {"lump of lead (large)",ROCKS},{"lump of gold (large)",ROCKS},{"lump of lead (medium)",ROCKS},
    {"lump of gold (medium)",ROCKS},{"lump of lead (small)",ROCKS},{"lump of gold (small)",ROCKS},
    {"snowman potion",FLASKS},{"(snowman potion)",ANIMATION},{"(snowman potion)",ANIMATION},
    {"(snowman potion)",ANIMATION},{"crystal fuzz",MISC},{"hot air",FLASKS},{"crystal seeds",MISC},
    {"magic shoe horn",MISC},{"twigs",MISC},{"charcoal",ROCKS},{"snow ball",ROCKS},{"moss",MISC},
    {"rolling stone",ROCKS},{"(rolling stone)",ANIMATION},{"(rolling stone)",ANIMATION},
    {"(rolling stone)",ANIMATION},{"jack",MISC},{"toy drum",MISC},{"(toy drum)",ANIMATION},
    {"(toy drum)",ANIMATION},{"(toy drum)",ANIMATION},{"feather duster",MISC},{"broom",MISC},
    {"lollipop",FOOD},{"icicle",MISC},{"musk",MISC},{"gold cannon ball",ROCKS},{"cannon ball",ROCKS},{"candy",FOOD},
    {"gear",MISC},{"(hot air)",ANIMATION},{"(hot air)",ANIMATION},{"(hot air)",ANIMATION},
    {"anchor stone",ROCKS},{"feathers",MISC},{"whistle",MISC},{"abomitable snowman potion",FLASKS},
    {"(abomitable snowman potion)",ANIMATION},{"(abomitable snowman potion)",ANIMATION},
    {"(abomitable snowman potion)",ANIMATION},{"secret potion",FLASKS},{"(secret potion)",ANIMATION},
    {"(secret potion)",ANIMATION},{"(secret potion)",ANIMATION},{"party favors potion",FLASKS},
    {"(party favors potion)",ANIMATION},{"(party favors potion)",ANIMATION},{"(party favors potion)",ANIMATION},
    {"cologne",FLASKS},{"silver statuette",MISC},{"rainbow stone",ROCKS},
    {"domino",MISC},{"top hat",MISC},{"tinker's bell",MISC},{"candle",MISC},{"sandwich potion",FLASKS},
    {"flying shoes potion",FLASKS},{"teddy bear potion",FLASKS},{"icicle",MISC},{"pine cone",MISC},
    {"acorn",MISC},{"walnut",MISC},{"orange peel",FOOD},{"indigo potion",FLASKS},{"amethyst",ROCKS},
    {"red potion",FLASKS},{"blue potion",FLASKS},{"",NULL}
};

// define all global variables/classes
screentype screen;
mousetype mouse;

//
#pragma argsused
void main (int argc, char *argv[])
{
    // check our CRC
    #if !defined(NO_CRC_CHECK)
        FILE *fp;
        filecrc crc;
        if ((fp = fopen(argv[0], "rb")) == NULL) bad_crc();
        fseek(fp, 0x23, SEEK_SET); fread(&crc, sizeof(filecrc), 1, fp); fclose(fp);
        if (stealth_file_check(argv[0], crc)) bad_crc();
    #endif

    // do the shareware stuff
    shareware_annoyance();

    // main loop
    while (1) {
        // main screen
        int savedgame_number = main_screen();
        if (savedgame_number == 0) break;

        // read in the inventory list for that game
        int inventory_list[20];
        read_inventory(savedgame_number, inventory_list);

        // inventory screen
        while (1) {
            int itemnumber = do_inventory_list(inventory_list);
            if (itemnumber == 0) {
                // write out the new inventory list
                write_inventory(savedgame_number, inventory_list);
                break;
            } else if (itemnumber == -1) break;

            edit_item(&inventory_list[itemnumber - 1]);
        }
    }
    exit(1);
}
//
int main_screen (void)
{
    // clear the screen
    screen.drawrepeat('', 80*25, 1, 1, COLOR(LIGHT_WHITE, LIGHT_BLUE));
    screen.refresh();

    // read in all of the saved games names
    int i, length = 1;
    char *buffer = new char[length];
    if (buffer == NULL) no_memory();
    strcpy(buffer, "");
    for (i = 1; i <= 999; i++) {
        char filename[13];

        sprintf(filename, "FATE_%03i.SAV", i);
        if (file_exists(filename)) {
            char title[81], *temp;
            FILE *fp;

            if ((fp = fopen(filename, "rb")) == NULL) file_error();
            memset(title, 0, 80);
            fread(title, sizeof(char), 80, fp);
            fclose(fp);

            length += strlen(title) + 1;
            temp = new char[length];
            if (temp == NULL) no_memory();
            strcpy(temp, buffer);
            strcat(temp, title);
            strcat(temp, "\n");
            delete buffer;
            buffer = temp;
        } else {
            break;
        }
    }
    if (length == 1) no_games();

    // create all controls that we'll use
    buttontype edit_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY), \
        3, 60, "Edit game");
    buttontype quit_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY), \
        8, 60, "Quit editor");
    menuboxtype saved_games(COLOR(BLACK, WHITE), COLOR(WHITE, BLACK), \
        COLOR(GRAY, WHITE), 2, 10, 21, buffer);
    delete buffer;

    // main input loop
    while (1) {
        // handle the menu box
        saved_games.handle();

        // quit button
        quit_button.handle();
        if (quit_button.pressed) {
            #define QUIT_ROW 12
            #define QUIT_COL 24
            screen.save();
            textboxtype message(COLOR(LIGHT_WHITE, BLUE), COLOR(LIGHT_YELLOW, BLUE), \
                QUIT_ROW, QUIT_COL, 31, 10, "\nDo you really want to quit?\n");
            menuboxtype yesno(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, BLACK), COLOR(GRAY, WHITE), \
                QUIT_ROW + 4, QUIT_COL + 11, 2, "Yes\nNo\n");
            screen.refresh();
            while (yesno.currentchoice == 0 || mouse.button) {
                message.handle();
                yesno.handle();
            }
            if (yesno.currentchoice == 1) return(0);
            screen.restore();
        }

        // edit button
        edit_button.handle();
        if (edit_button.pressed && saved_games.currentchoice) break;
    }
    return(saved_games.currentchoice);
}
//
void read_inventory(int savedgame_number, int inventory_list[])
{
    FILE *fp;
    char filename[13];

    sprintf(filename, "FATE_%03i.SAV", savedgame_number);
    if ((fp = fopen(filename, "rb")) == NULL) file_error();
    fseek(fp, 0x269, SEEK_SET);
    fread(inventory_list, sizeof(int), 20, fp);
    fclose(fp);
}
//
void write_inventory(int savedgame_number, int inventory_list[])
{
    FILE *fp;
    char filename[13];

    sprintf(filename, "FATE_%03i.SAV", savedgame_number);
    if ((fp = fopen(filename, "r+b")) == NULL) file_error();
    fseek(fp, 0x269, SEEK_SET);
    fwrite(inventory_list, sizeof(int), 20, fp);
    fclose(fp);
}
//
int do_inventory_list(int inventory_list[])
{
    // clear the screen
    screen.drawrepeat('', 80*25, 1, 1, COLOR(LIGHT_WHITE, LIGHT_BLUE));
    screen.refresh();

    // create a list of the items currently carried
    int length = 1, i;
    char *buffer = new char[length];
    if (buffer == NULL) no_memory();
    strcpy(buffer, "");
    for (i = 0; i < 20; i++) {
        if (inventory_list[i] != -1) {
            length += strlen(item_data[inventory_list[i]].name) + 1;
        } else {
            length += strlen("* NOTHING *") + 1;
        }
        char *temp = new char[length];
        if (temp == NULL) no_memory();
        strcpy(temp, buffer);
        if (inventory_list[i] != -1) {
            strcat(temp, item_data[inventory_list[i]].name);
        } else {
            strcat(temp, "* NOTHING *");
        }
        strcat(temp, "\n");
        delete buffer;
        buffer = temp;
    }

    // create all controls that we'll use
    buttontype edit_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY),
        3, 60, "Edit item");
    buttontype save_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY),
        8, 60, "Save changes");
    buttontype discard_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY),
        13, 60, "Discard changes");
    menuboxtype inventory(COLOR(BLACK, WHITE), COLOR(WHITE, BLACK), COLOR(GRAY, WHITE), \
            2, 10, 20, buffer);
    delete buffer;

    // main input loop
    while (1) {
        // handle the menu box
        inventory.handle();

        // save button
        save_button.handle();
        if (save_button.pressed) return(0);

        // discard button
        discard_button.handle();
        if (discard_button.pressed) return(-1);

        // edit button
        edit_button.handle();
        if (edit_button.pressed && inventory.currentchoice) {
            return(inventory.currentchoice);
        }
    }
}
//
void edit_item(int *item_id)
{
    // editing screen
    screen.drawrepeat('', 80*25, 1, 1, COLOR(LIGHT_WHITE, LIGHT_BLUE));
    buttontype save_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY),
        3, 60, "Save changes");
    save_button.draw();
    buttontype discard_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY),
        8, 60, "Discard changes");
    discard_button.draw();
    buttontype nothing_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY),
        22, 3+1, "Nothing");
    nothing_button.draw();
    buttontype food_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY),
        22, 3+13, "Food");
    food_button.draw();
    buttontype flasks_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY),
        22, 3+22, "Flasks");
    flasks_button.draw();
    buttontype rocks_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY),
        22, 3+33, "Rocks");
    rocks_button.draw();
    buttontype metal_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY),
        22, 3+43, "Metal");
    metal_button.draw();
    buttontype misc_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY),
        22, 3+53, "Misc");
    misc_button.draw();
    buttontype animation_button(COLOR(BLACK, LIGHT_WHITE), COLOR(LIGHT_WHITE, GRAY),
        22, 3+62, "Animation");
    animation_button.draw();
    screen.refresh();
    screen.save();

    // create list handling variables
    menuboxtype *item_menu;
    int create_list, create_item, current_list;
    if (*item_id == -1) {
        current_list = create_list = -1; create_item = 1;
    } else {
        current_list = create_list = item_data[*item_id].type;
        int i, j = item_data[*item_id].type, count = 0;
        for (i = 0; item_data[i].type != NULL; i++) {
            if (item_data[i].type == j) {
                count++;
                if (i == *item_id) {create_item = count; break;}
            }
        }
    }

    // main input routine
    while (1) {
        if (create_list) {
            item_menu = create_item_list(create_list);
            item_menu->currentchoice = create_item;
            screen.restore();
            switch (create_list) {
                case -1: screen.drawstring("Nothing", 2, 10, COLOR(LIGHT_WHITE, LIGHT_BLUE)); break;
                case FOOD: screen.drawstring("Food", 2, 10, COLOR(LIGHT_WHITE, LIGHT_BLUE)); break;
                case FLASKS: screen.drawstring("Flasks", 2, 10, COLOR(LIGHT_WHITE, LIGHT_BLUE)); break;
                case ROCKS: screen.drawstring("Rocks", 2, 10, COLOR(LIGHT_WHITE, LIGHT_BLUE)); break;
                case METAL: screen.drawstring("Metal", 2, 10, COLOR(LIGHT_WHITE, LIGHT_BLUE)); break;
                case MISC: screen.drawstring("Misc", 2, 10, COLOR(LIGHT_WHITE, LIGHT_BLUE)); break;
                case ANIMATION: screen.drawstring("Animation", 2, 10, COLOR(LIGHT_WHITE, LIGHT_BLUE)); break;
                default: break;
            }
            create_list = 0;
        }

        item_menu->handle();
        save_button.handle();
        if (save_button.pressed) {
            if (current_list == -1) {
                *item_id = -1;
            } else {
                int i, count = 0;
                for (i = 0; item_data[i].type != NULL; i++) {
                    if (item_data[i].type == current_list) {
                        count++;
                        if (count == item_menu->currentchoice) {*item_id = i; break;}
                    }
                }
            }
            break;
        }
        discard_button.handle();
        if (discard_button.pressed) break;

        nothing_button.handle();
        if (nothing_button.pressed) {delete item_menu; current_list = create_list = -1; create_item = 1;}
        food_button.handle();
        if (food_button.pressed) {delete item_menu; current_list = create_list = FOOD; create_item = 1;}
        flasks_button.handle();
        if (flasks_button.pressed) {delete item_menu; current_list = create_list = FLASKS; create_item = 1;}
        rocks_button.handle();
        if (rocks_button.pressed) {delete item_menu; current_list = create_list = ROCKS; create_item = 1;}
        metal_button.handle();
        if (metal_button.pressed) {delete item_menu; current_list = create_list = METAL; create_item = 1;}
        misc_button.handle();
        if (misc_button.pressed) {delete item_menu; current_list = create_list = MISC; create_item = 1;}
        animation_button.handle();
        if (animation_button.pressed) {delete item_menu; current_list = create_list = ANIMATION; create_item = 1;}
    }

    delete item_menu;
}
//
menuboxtype *create_item_list(int item_type)
{
    if (item_type != -1) {
        char *buffer; int i, length;
        for (i = 0, length = 1; item_data[i].type != NULL; i++) {
            if (item_data[i].type == item_type) length += strlen(item_data[i].name) + 1;
        }
        buffer = new char[length];
        if (buffer == NULL) no_memory();
        strcpy(buffer, "");
        for (i = 0; item_data[i].type != NULL; i++) {
            if (item_data[i].type == item_type) {
                strcat(buffer, item_data[i].name);
                strcat(buffer, "\n");
            }
        }
        menuboxtype *tempmenu = new menuboxtype(COLOR(BLACK, WHITE), \
            COLOR(WHITE, BLACK), COLOR(GRAY, WHITE), 3, 10, 16, buffer);
        delete buffer;
        return(tempmenu);
    } else {
        menuboxtype *tempmenu = new menuboxtype(COLOR(BLACK, WHITE), \
            COLOR(WHITE, BLACK), COLOR(GRAY, WHITE), 3, 10, 16, "* NOTHING *\n");
        return(tempmenu);
    }
}
//
// return true if the specified file name exists
int file_exists (char *filename)
{
    struct ffblk f;
    return (!findfirst(filename, &f, 0));
}
//
