// []-----------------------------------------------------------------------[]
// |                                                                         |
// |                                                                         |
// |  This source and its associated executable are copyright by Jeff Lawson |
// |  of JL Enterprises, however some portions of this code may or may not   |
// |  have been originally inspired by other authors and credit is given if  |
// |  due.  You are encouraged to redistribute this package, but you must    |
// |  include all files originally distributed in this archive in their      |
// |  original state and format and without modifications of any kind.       |
// |  Under no circumstances may you make modifications to this product and  |
// |  redistribute the resulting code or executables.  If you believe you    |
// |  have made some useful or otherwise important enhancements and you      |
// |  would like to share these changes with others, please contact the      |
// |  author through one of the methods listed below.  Additionally, no      |
// |  fees may be charged for the usage of this product by anyone other than |
// |  the author of this file, except for fees (not to exceed US $10) by     |
// |  disk distributors to cover disk duplication and handling.  If there    |
// |  is any need to question this policy, please contact the author.        |
// |  This source code and its executable are distributed without any kind   |
// |  of warranty and the author may not be held accountable for damages of  |
// |  any kind.                                                              |
// |                                                                         |
// |                                                                         |
// |  I can reached via postal mail at:                                      |
// |                                                                         |
// |          Jeff Lawson                                                    |
// |          1893 Kaweah Drive                                              |
// |          Pasadena, CA 91105-2174                                        |
// |          USA                                                            |
// |                                                                         |
// |  or through E-mail at:                                                  |
// |                                                                         |
// |          jlawson@hmc.edu    or   JeffLawson@Aol.Com                     |
// |                                                                         |
// |  also via phone at:                                                     |
// |                                                                         |
// |          (213) 258-5604     or   (213) 258-4264                         |
// |                                                                         |
// []-----------------------------------------------------------------------[]

#include <stdlib.h>
#include <conio.h>
#include <stdio.h>
#include <time.h>
#include <dos.h>
#include <dir.h>
#include <string.h>
#include <iostream.h>
#include "screen.hpp"
#include "colors.hpp"
#include "button.hpp"
#include "menubox.hpp"
#include "textbox.hpp"
#include "txtinput.hpp"
#include "stealth.h"

#define REGFILE "HOFEDIT.REG"
#define REGCODE "2Y7QAKXCJ9"
#define APPNAME "HOFEDIT"

// some defines
#define TRUE 1
#define FALSE 0

// define the item types
#define FOOD 1
#define FLASKS 2
#define ROCKS 3
#define METAL 4
#define MISC 5
#define ANIMATION 6

// define the item information list
extern struct item_type {
    char name[30];
    int type;
} item_data[];

// declare all error messages we'll use
extern void no_memory (void);
extern void no_mouse (void);
extern void no_VGA (void);
extern void no_games (void);
extern void file_error (void);
extern void bad_crc (void);
extern void no_copies (void);

// declare all function prototypes
extern void shareware_annoyance(void);
extern int main_screen (void);
extern void read_inventory(int savedgame_number, int inventory_list[]);
extern void write_inventory(int savedgame_number, int inventory_list[]);
extern int do_inventory_list(int inventory_list[]);
extern void edit_item(int *item_id);
extern menuboxtype *create_item_list(int item_type);
extern int file_exists (char *filename);


